// export const _default = async function (fields, params = Object) {
//   await func.utils.load_js_on_demand(
//     func.common.get_url(
//       params.SESSION_ID,
//       "dist",
//       "runtime/node_modules/@xuda.io/firebase-app/index.js"
//     )
//   );

//   if (!params?.plugin_setup?.[params.propsP.setup_account_id]) {
//     return params.report_error("setup account error");
//   }

//   const _config = params.plugin_setup[params.propsP.setup_account_id];

//   var firebaseConfig = {
//     apiKey: _config.apiKey,
//     authDomain: _config.authDomain,
//     databaseURL: _config.databaseURL,
//     projectId: _config.projectId,
//     storageBucket: _config.storageBucket,
//     messagingSenderId: _config.messagingSenderId,
//     appId: _config.appId,
//     measurementId: _config.measurementId,
//   };
//   try {
//     firebase.initializeApp(firebaseConfig);
//   } catch (error) {
//     params.report_error(error);
//   }
// };

export const beforeInit = async (e) => {
  // console.log("beforeInit");
};
export const initialized = async (e) => {
  console.log("initialized");

  const firebase = await import(
    "https://www.gstatic.com/firebasejs/9.17.0/firebase-app.js"
  );

  const analytics = await import(
    "https://www.gstatic.com/firebasejs/9.17.1/firebase-analytics.js"
  );

  if (!e?.setup_data?.accounts) {
    return;
  }

  e.session_data.FIREBASE = { app: {}, analytics: {} };

  for await (const [account, val] of Object.entries(e.setup_data.accounts)) {
    const firebaseConfig = {
      apiKey: val.data.apiKey,
      authDomain: val.data.authDomain,
      projectId: val.data.projectId,
      storageBucket: val.data.storageBucket,
      messagingSenderId: val.data.messagingSenderId,
      appId: val.data.appId,
      measurementId: val.data.measurementId,
    };
    const app = firebase.initializeApp(firebaseConfig);
    e.session_data.FIREBASE_APP[account].app = app;
    e.session_data.FIREBASE_APP[account].analytics =
      analytics.getAnalytics(app);
  }

  // await e.xu_api.set_field_value(e.SESSION_ID, "GLB_Test", 1967);
};

export const beforeMounted = async ({ SESSION_ID, app_obj, setup_data }) => {
  // console.log("beforeMounted");
};
export const mounted = async ({ SESSION_ID, app_obj, setup_data }) => {
  // console.log("mounted");
};
export const systemReady = async ({ SESSION_ID, app_obj, setup_data }) => {
  // console.log("systemReady");
};
